%IG20 - loha 1 (Urcen neprstupn vzdlenosti)
%RSC (rsc@email.cz)

clear
clc

fid = 1;
fid = fopen('ig20_u01_3D.txt','w'); %vytvoreni *.txt souboru pro vystup

body_cisla = [1 2 3 4 5 251 252 253 254]'; %csla bodu jak jsou za sebou v seznamu

do = 5; %pro kolik bodu poctat (1 az do)

q = [%[m]       [mm]               body pro nez se maj poctat dlky a hly (Vsledky z Gamy/Rocinanty)
  -16.22125     0.3  %X mX
  -16.58435     0.3  %Y mY
    0.77924     0.1  %Z mZ
                    
   10.33472     0.2 
  -14.19354     0.3 
    1.58799     0.1 
                    
   15.67207     0.3 
   43.66603     0.5 
   11.17163     0.2 
                    
   -5.63948     0.3 
   41.60412     0.4 
   11.16306     0.2 
                    
   -2.87584     0.1 
  -12.66189     0.3 
   -0.74508     0.0  

   0 0
   0 0
   0 0
   
  15.29489     0.2 
  -0.00000     0.0 
   0.44496     0.0 
                   
   1.01415     0.1 
   1.18467     0.1 
   0.17478     0.1 
                   
  16.34196     0.2 
   1.17971     0.2 
   0.51190     0.1 
   
];


body = []; %bod X Y Z mY mY mZ

for i=1:max(size(q))/3
    body(i,1) = i;%prubezn csla bodu (1 az n)

    body(i,2) = q(3 * i - 2,1);
    body(i,3) = q(3 * i - 1,1);
    body(i,4) = q(3 * i    ,1);
    
    body(i,5) = q(3 * i - 2,2);
    body(i,6) = q(3 * i - 1,2);
    body(i,7) = q(3 * i    ,2);
    
end

body(:,1) = body_cisla;

fprintf(fid,'dlky:\n');
fprintf(fid,'    z    na      sikm    str.ch      vodorovn  str.ch       prevysen  str.ch\n');
fprintf(fid,'                  [m]      [mm]          [m]      [mm]           [m]      [mm]\n');
fprintf(fid,'-------------------------------------------------------------------------------\n');

for i=1:do
    for j=i+1:do
        [d,md,d0,md0,prev,mprev] = m_delka(body(i,2:7),body(j,2:7));
        fprintf(fid,'  %3.f   %3.f     %7.4f    %3.2f        %7.4f    %3.2f        %8.4f    %3.2f\n',body(i,1),body(j,1),d,md,d0,md0,prev,mprev);
    end
end



fprintf(fid,'\n\nzenitky:\n');
fprintf(fid,'    z    na       zenitka     protejs   str.ch\n');
fprintf(fid,'                    [g]         [g]       [cc]\n');
fprintf(fid,'----------------------------------------------------------------------------\n');

for i=1:do
    for j=i:do
        if(i ~= j)
            [zenit,mzenit] = m_zenit(body(i,2:7),body(j,2:7));
            fprintf(fid,'  %3.f   %3.f      %9.5f   %9.5f    %4.1f  \n',body(i,1),body(j,1),zenit,200-zenit,mzenit);
        end
    end
end


fprintf(fid,'\n\nvodorovn hly:\n');
fprintf(fid,'       rameno           hel      doplnek   str.ch\n');
fprintf(fid,'    L  vrchol   P       [g]         [g]      [cc]\n');
fprintf(fid,'----------------------------------------------------------------------------\n');
for i=1:do
    for j=1:do
        if(i ~= j)
            for(k=j+1:do)
                if(k ~= i)
                    [uhel,muhel] = m_uhel(body(j,2:7),body(i,2:7),body(k,2:7));
                    fprintf(fid,'  %3.f - %3.f - %3.f    %9.5f   %9.5f   %4.1f \n',body(j,1),body(i,1),body(k,1),uhel,400-uhel,muhel);
                end
            end
        end
    end
end


fclose(fid);
fprintf('\n\nVsledky jsou ulozeny v souboru "ig20_u01_3D.txt" v pracovnm adresri\n\n');
 